using Newtonsoft.Json;
using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Net;
using System.Net.Security;
using System.Security.Cryptography.X509Certificates;
using System.Text;
using System.Threading.Tasks;
using System.Web;

namespace Fuel.Payment.Service.AllInPayProcessor.AllInPay.Util
{
    public class HttpUtil
    {
        private static readonly string DefaultUserAgent = "Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.2; SV1; .NET CLR 1.1.4322; .NET CLR 2.0.50727)";
        private readonly static NLog.Logger _logger = NLog.LogManager.GetLogger("Main");

        private static bool CheckValidationResult(object sender, X509Certificate certificate, X509Chain chain, SslPolicyErrors errors)
        {
            return true; //总是接受     
        }

        public static async Task<string> CreatePostHttpResponseAsync(string url, IDictionary<string, string> parameters, Encoding charset)
        {
            HttpWebRequest request = null;
            //HTTPSQ请求  
            ServicePointManager.ServerCertificateValidationCallback = new RemoteCertificateValidationCallback(CheckValidationResult);
            request = WebRequest.Create(url) as HttpWebRequest;
            request.ProtocolVersion = HttpVersion.Version10;
            request.Method = "POST";
            request.ContentType = "application/x-www-form-urlencoded";
            request.UserAgent = DefaultUserAgent;
            //如果需要POST数据     
            if (!(parameters == null || parameters.Count == 0))
            {
                StringBuilder buffer = new StringBuilder();
                int i = 0;
                foreach (string key in parameters.Keys)
                {
                    if (i > 0)
                    {
                        buffer.AppendFormat("&{0}={1}", key, parameters[key]);
                    }
                    else
                    {
                        buffer.AppendFormat("{0}={1}", key, parameters[key]);
                    }
                    i++;
                }
                var bufString = buffer.ToString();
                _logger.Info($"AllInPay CreatePostHttpResponse request: {bufString}");
                byte[] data = charset.GetBytes(buffer.ToString());
                using (Stream stream = request.GetRequestStream())
                {
                    stream.Write(data, 0, data.Length);
                }
            }
            var response = await request.GetResponseAsync().ConfigureAwait(false);   //获取响应的字符串流  
            var outstream = response.GetResponseStream();
            StreamReader sr = new StreamReader(outstream); //创建一个stream读取流  
            return sr.ReadToEnd();

        }

        public static async Task<string> CreatePostHttpResponseAsync(string url, IDictionary<string, object> parameters, Encoding charset)
        {
            HttpWebRequest request = null;
            //HTTPSQ请求  
            ServicePointManager.ServerCertificateValidationCallback = new RemoteCertificateValidationCallback(CheckValidationResult);
            request = WebRequest.Create(url) as HttpWebRequest;
            request.ProtocolVersion = HttpVersion.Version10;
            request.Method = "POST";
            request.ContentType = "application/x-www-form-urlencoded";
            request.UserAgent = DefaultUserAgent;
            //如果需要POST数据     
            if (!(parameters == null || parameters.Count == 0))
            {
                StringBuilder buffer = new StringBuilder();
                int i = 0;
                foreach (string key in parameters.Keys)
                {
                    if (key == "key")
                    {
                        continue;
                    }

                    var value = parameters[key];
                    if (!(value is string))
                    {
                        value = JsonConvert.SerializeObject(value);
                    }
                    if (i > 0)
                    {
                        buffer.AppendFormat("&{0}={1}", key, value);
                    }
                    else
                    {
                        buffer.AppendFormat("{0}={1}", key, value);
                    }
                    i++;
                }
                var bufString = buffer.ToString();
                _logger.Info($"AllInPayV2 CreatePostHttpResponse request: {bufString}");
                var urlEncodedStr = HttpUtility.UrlEncode(bufString);
                byte[] data = charset.GetBytes(buffer.ToString());
                using (Stream stream = await request.GetRequestStreamAsync().ConfigureAwait(false))
                {
                    stream.Write(data, 0, data.Length);
                }
            }
            var response = await request.GetResponseAsync().ConfigureAwait(false);   //获取响应的字符串流
            var outstream = response.GetResponseStream();
            StreamReader sr = new StreamReader(outstream); //创建一个stream读取流  
            return sr.ReadToEnd();

        }
    }
}
